test1: exercise_05_16
	@echo "Running $@..."
	@./$< < $@.input > $@.output
	@diff $@.output $@.expected > /dev/null && echo "$@ PASSED" || echo "$@ FAILED"

exercise_05_16: exercise_05_16.o | .gitignore
	g++ -Wall -Wextra -Werror -std=c++03 -g3 $^ -o $@

%.ii: %.cpp
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -E $< -o $@

%.s: %.ii
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -S $< -o $@

%.o: %.s
	g++ -Wall -Wextra -Werror -std=c++03 -g3 -c $< -o $@

.gitignore:
	echo exercise_05_16 > $@

clean:
	rm -rf *.ii *.s *.o *.output exercise_05_16

.PRECIOUS: exercise_05_16.ii exercise_05_16.s
.SECONDARY: exercise_05_16.ii exercise_05_16.s

